package service

import (
	"time"

	"git.bvbej.com/bvbej/base-golang/pkg/websocket/peer"
)

type Component interface {
	Init()
	OnSessionClose(*peer.Session) bool
	OnRequestFinished(*peer.Session, string, interface{}, string, time.Duration)
}

type ComponentBase struct{}

func (c *ComponentBase) Init() {

}

func (c *ComponentBase) OnSessionClose(session *peer.Session) bool {
	return false
}

func (c *ComponentBase) OnRequestFinished(session *peer.Session, router string, req interface{}, errMsg string, delta time.Duration) {

}
